/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

#ifndef	__ECBCFG_H__
#define __ECBCFG_H___

typedef struct corba_init {
	CORBA_char		*corba_tgtnam;
	CORBA_unsigned_long	corba_srvnum;
	CORBA_unsigned_long	corba_memsz;
	CORBA_char		*corba_buffp;
	void			*corba_rfu1;
	void			*corba_rfu2;
	void			*corba_rfu3;
	void			*corba_rfu4;
} CORBA_UsrDefine;

typedef struct asrv_usrdef {
	ID			asrv_aservid;
	PRI			asrv_asrvpri;
	PRI			asrv_dsrvpri;
	CORBA_unsigned_short	asrv_portnum;
	CORBA_unsigned_long	asrv_dservnm;
	CORBA_unsigned_long	asrv_ddobjnm;
	void			*asrv_rfu1;
	void			*asrv_rfu2;
	void			*asrv_rfu3;
	void			*asrv_rfu4;
} ASRV_UsrDefine;

typedef struct orb_usrdef {
	void			*orb_rfu1;
	void			*orb_rfu2;
	void			*orb_rfu3;
	void			*orb_rfu4;
} ORB_UsrDefine;

typedef struct tagPOA_UsrDefine {
	CORBA_unsigned_long	poa_limit;
	CORBA_unsigned_long	map_limit;
	void	*poa_rfu1;
	void	*poa_rfu2;
	void			*poa_rfu3;
	void			*poa_rfu4;
} POA_UsrDefine;

typedef struct mrshl_usrdef {
	void			*mrshl_rfu1;
	void			*mrshl_rfu2;
	void			*mrshl_rfu3;
	void			*mrshl_rfu4;
} MRSHL_UsrDefine;

typedef struct giop_usrdef {
	void			*giop_rfu1;
	void			*giop_rfu2;
	void			*giop_rfu3;
	void			*giop_rfu4;
} GIOP_UsrDefine;

typedef struct con_usr_define {
	CORBA_unsigned_long	con_srvlim;
	CORBA_unsigned_long	con_clilim;
	CORBA_unsigned_long	con_tmout;
	void			*con_rfu1;
	void			*con_rfu2;
	void			*con_rfu3;
	void			*con_rfu4;
} CON_UsrDefine;

typedef struct sys_usrdef {
	void	*sys_rfu1;
	void	*sys_rfu2;
	void	*sys_rfu3;
	void	*sys_rfu4;
} SYS_UsrDefine;

typedef struct sg {
	CORBA_UsrDefine		*sg_corba;
	ASRV_UsrDefine		*sg_asrv;
	ORB_UsrDefine		*sg_orb;
	POA_UsrDefine		*sg_poa;
	MRSHL_UsrDefine		*sg_mrshl;
	GIOP_UsrDefine		*sg_giop;
	CON_UsrDefine		*sg_con;
	SYS_UsrDefine		*sg_sys;
	void			*sg_rfu1;
	void			*sg_rfu2;
	void			*sg_rfu3;
	void			*sg_rfu4;
} SG_CORBA;

#endif /* __ECBCFG_H__ */
