/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

#ifndef	__ECBPOA_H__
#define __ECBPOA_H__

typedef	void	*PortableServer_Servant;
typedef CORBA_sequence_octet	PortableServer_ObjectId;

struct tagPOA_struct;
typedef struct tagPOA_struct *PortableServer_POA;
struct tagCORBA_Policy_struct;
typedef struct tagCORBA_Policy_struct *CORBA_Policy;
struct tagLifespanPolicy_struct;
typedef struct tagLifespanPolicy_struct	*PortableServer_LifespanPolicy;
struct tagCORBA_sequence_Policy;
typedef struct tagCORBA_sequence_Policy CORBA_PolicyList;
struct tagPOAManager;
typedef	struct tagPOAManager *PortableServer_POAManager;

typedef struct tagCORBA_sequence_Policy {
	CORBA_unsigned_long	_maximum;
	CORBA_unsigned_long	_length;
	CORBA_Policy	*_buffer;
	CORBA_boolean	_release;
} CORBA_sequence_Policy;

typedef struct tagPOA_ObjectKey {
	CORBA_char *poa_name;
	PortableServer_ObjectId *oid;
} POA_ObjectKey;

typedef enum tagCORBA_PolicyType {
	LifespanPolicyType
} CORBA_PolicyType;

typedef enum tagPortableServer_LifespanPolicyValue {
	PortableServer_TRANSIENT,
	PortableServer_PERSISTENT,
	PortableServer_AMBIGUOUS
} PortableServer_LifespanPolicyValue;

/*
   $B%9%1%k%H%s$GI,MW$J7?Dj5A(B
 */
typedef struct tagPortableServer_ServantPrivateInfo {
	CORBA_char *idl_type;
	void	(*dispatch_function)(PortableServer_Servant,
				     GIOP_SrvInf *msg);
} PortableServer_ServantPrivateInfo;

typedef struct PortableServer_ServantBase__epv {
	void	*_private;
	void	(*finalize)(PortableServer_Servant,
			    CORBA_Environment *);
	PortableServer_POA	(*default_POA)(PortableServer_Servant,
					       CORBA_Environment *);
} PortableServer_ServantBase__epv;

typedef PortableServer_ServantBase__epv	*PortableServer_ServantBase__vepv;

typedef struct PortableServer_ServantBase {
	void	*_private;
	PortableServer_ServantBase__epv	*vepv;
} PortableServer_ServantBase;

/*
   $B4X?t%W%m%H%?%$%W@k8@(B
 */
CORBA_boolean POA_init(CORBA_UsrDefine *, POA_UsrDefine *);
void POA_fini();
CORBA_unsigned_long POA_remain_poa();
CORBA_unsigned_long POA_remain_active_object_map();

CORBA_sequence_Policy *CORBA_sequence_Policy__alloc();
void CORBA_sequence_Policy__free(void *);
CORBA_Policy *CORBA_sequence_Policy_allocbuf(CORBA_unsigned_long);

PortableServer_POA PortableServer_POA_create_POA(PortableServer_POA,
					       CORBA_char *,
					       PortableServer_POAManager,
					       CORBA_PolicyList *,
					       CORBA_Environment *);

void PortableServer_POA_destroy(PortableServer_POA,
				   CORBA_boolean,
				   CORBA_boolean,
				   CORBA_Environment *);


CORBA_char *PortableServer_POA__get_the_name(PortableServer_POA,
					    CORBA_Environment *);

PortableServer_POA PortableServer_POA__get_the_parent(PortableServer_POA,
					      CORBA_Environment *);

PortableServer_POAManager PortableServer_POA__get_the_POAManager
					(PortableServer_POA,
					  CORBA_Environment *);

void PortableServer_POA_activate_object_with_id(PortableServer_POA,
						   PortableServer_ObjectId *,
						   PortableServer_Servant,
						   CORBA_Environment *);

void PortableServer_POA_deactivate_object_with_id(PortableServer_POA,
						     PortableServer_ObjectId,
						     CORBA_Environment *);

PortableServer_LifespanPolicyValue
PortableServer_LifespanPolicy__get_value(PortableServer_LifespanPolicy policy,
			  CORBA_Environment *);

PortableServer_LifespanPolicy
PortableServer_POA_create_lifespan_policy(PortableServer_POA,
					    PortableServer_LifespanPolicyValue,
					    CORBA_Environment *);
void
PortableServer_POA_deactivate_object(PortableServer_POA,
                                     PortableServer_ObjectId *,
                                     CORBA_Environment *);

PortableServer_POA
PortableServer_POA_find_POA(PortableServer_POA,
			    CORBA_char *,
			        CORBA_boolean,
			    CORBA_Environment *);

CORBA_Object
PortableServer_POA_servant_to_reference(PortableServer_POA,
					PortableServer_Servant,
					CORBA_Environment *);
CORBA_Object
PortableServer_POA_id_to_reference(PortableServer_POA,
				      PortableServer_ObjectId *,
				      CORBA_Environment *);

PortableServer_Servant
PortableServer_POA_id_to_servent(PortableServer_POA,
				  PortableServer_ObjectId *,
				  CORBA_Environment *);

PortableServer_ObjectId *
PortableServer_POA_reference_to_id(PortableServer_POA,
				      CORBA_Object,
				      CORBA_Environment *);

void
PortableServer_POAManager_activate(PortableServer_POAManager,
                                   CORBA_Environment *);
void
PortableServer_POAManager_deactivate(PortableServer_POAManager,
                                   CORBA_Environment *);

CORBA_char*
PortableServer_ObjectId_to_string(PortableServer_ObjectId *,
				  CORBA_Environment *);
PortableServer_ObjectId *
PortableServer_string_to_ObjectId(CORBA_char *,
				  CORBA_Environment *);

PortableServer_ObjectId *
PortableServer_POA_servant_to_id(PortableServer_POA,
				 PortableServer_Servant,
				 CORBA_Environment *);


#define	CORBA_Ex_ORB_InvalidName	"IDL:CORBA/ORB/InvalidName:1.0"
#define	CORBA_Ex_PortableServer_POA_AdapterAlreadyExists	"IDL:CORBA/POA/AdapterAlreadyExists:1.0"
#define	CORBA_Ex_PortableServer_POA_AdapterNonExistent	"IDL:CORBA/POA/AdapterNonExistent:1.0"
#define	CORBA_Ex_PortableServer_POA_InvalidPolicy	"IDL:CORBA/POA/InvalidPolicy:1.0"
#define	CORBA_Ex_PortableServer_POA_ObjectAlreadyActive	"IDL:CORBA/POA/ObjectAlreadyActive:1.0"
#define CORBA_Ex_PortableServer_POA_ServantAlreadyActive	"IDL:CORBA/POA/ServantAlreadyActive:1.0"
#define	CORBA_Ex_PortableServer_POA_ObjectNotActive	"IDL:CORBA/POA/ObjectNotActive:1.0"
#define	CORBA_Ex_PortableServer_POA_ServantNotActive	"IDL:CORBA/POA/ServantNotActive:1.0"
#define	CORBA_Ex_PortableServer_POA_ObjectNotActive	"IDL:CORBA/POA/ObjectNotActive:1.0"
#define	CORBA_Ex_PortableServer_POA_AdapterInactive	"IDL:CORBA/POA/AdapterInactive:1.0"

#endif	/* __ECBPOA_H__ */
