/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

#ifndef	__ECBGIOP_H__
#define __ECBGIOP_H__

/*
 *	̿Хåեѹ¤
 */
typedef struct giop_mem_info {
	CORBA_unsigned_long	mem_bsize;	/* buf size */
	CORBA_char		*mem_btopp;	/* malloc buf top pointer */
	CORBA_char		*mem_bcurp;	/* malloc buf cur pointer */
} GIOP_MemInf;

struct srv_resource;

/*
 *	¦GIOPѹ¤
 */
typedef struct srv_info {
	GIOP_MemInf		srv_memif;	/* memory infomation */
#define srv_bsize	srv_memif.mem_bsize
#define srv_btopp	srv_memif.mem_btopp
#define srv_bcurp	srv_memif.mem_bcurp
	CORBA_boolean		srv_bordr;	/* request byte order */
	CORBA_char		*srv_cntxt;	/* service context pointer */
	CORBA_unsigned_long	srv_reqid;	/* request id */
	CORBA_boolean		srv_akflg;	/* reply ack flag */
	CORBA_sequence_octet	srv_keyhd;	/* object_key Header Info */
#define srv_hdmax	srv_keyhd._maximum
#define srv_hdlen	srv_keyhd._length
#define srv_hdbfp	srv_keyhd._buffer
#define srv_hdrls	srv_keyhd._release
	CORBA_sequence_octet	srv_obkey;	/* object_key Info */
#define srv_kymax	srv_obkey._maximum
#define srv_kylen	srv_obkey._length
#define srv_kybfp	srv_obkey._buffer
#define srv_kyrls	srv_obkey._release
	CORBA_char		*srv_opnam;	/* opname pointer in request buf */
	struct srv_resource	*srv_conct;	/* connection info */
} GIOP_SrvInf;

#define GIOP_srv_bsize(m)	(((GIOP_SrvInf *)m)->srv_bsize)
#define GIOP_srv_btopp(m)	(((GIOP_SrvInf *)m)->srv_btopp)
#define GIOP_srv_bcurp(m)	(((GIOP_SrvInf *)m)->srv_bcurp)
#define GIOP_srv_bordr(m)	(((GIOP_SrvInf *)m)->srv_bordr)
#define GIOP_srv_reqid(m)	(((GIOP_SrvInf *)m)->srv_reqid)
#define GIOP_srv_akflg(m)	(((GIOP_SrvInf *)m)->srv_akflg)
#define GIOP_srv_opnam(m)	(((GIOP_SrvInf *)m)->srv_opnam)
#define GIOP_srv_hdlen(m)	(((GIOP_SrvInf *)m)->srv_hdlen)
#define GIOP_srv_hdbfp(m)	(((GIOP_SrvInf *)m)->srv_hdbfp)
#define GIOP_srv_kylen(m)	(((GIOP_SrvInf *)m)->srv_kylen)
#define GIOP_srv_kybfp(m)	(((GIOP_SrvInf *)m)->srv_kybfp)

/*
 *	¦GIOPåѥޥ
 */
#define GIOP_end_srv(inf)	GIOP_free(&(((GIOP_SrvInf *)inf)->srv_memif))

/*
 *	饤¦GIOPѹ¤
 */
typedef struct cli_info {
	GIOP_MemInf		cli_memif;	/* memory infomation */
#define cli_bsize	cli_memif.mem_bsize
#define cli_btopp	cli_memif.mem_btopp
#define cli_bcurp	cli_memif.mem_bcurp
	CORBA_boolean		cli_bordr;	/* request byte order */
	CORBA_unsigned_long	cli_reqid;	/* request id */
	CORBA_boolean		cli_akflg;	/* reply ack flag */
	CORBA_boolean		cli_fowrd;	/* location forward flag */
} GIOP_CliInf;

#define GIOP_cli_bsize(m)	(((GIOP_CliInf *)m)->cli_bsize)
#define GIOP_cli_btopp(m)	(((GIOP_CliInf *)m)->cli_btopp)
#define GIOP_cli_bcurp(m)	(((GIOP_CliInf *)m)->cli_bcurp)
#define GIOP_cli_bordr(m)	(((GIOP_CliInf *)m)->cli_bordr)
#define GIOP_cli_reqid(m)	(((GIOP_CliInf *)m)->cli_reqid)
#define GIOP_cli_akflg(m)	(((GIOP_CliInf *)m)->cli_akflg)
#define GIOP_cli_fowrd(m)	(((GIOP_CliInf *)m)->cli_fowrd)

/*
 *	饤¦GIOPåѥޥ
 */
#define GIOP_end_cli(inf)	GIOP_free(&(((GIOP_CliInf *)inf)->cli_memif))

/*
 *	GIOP RplyStatusType
 */
typedef enum {
	GIOP_NO_EXCEPTION = 0, GIOP_USER_EXCEPTION, GIOP_SYSTEM_EXCEPTION,
	GIOP_LOCATION_FORWARD
} GIOP_RplyStatusType;

/*
 *	ץȥ
 */
void GIOP_free(GIOP_MemInf *);
void GIOP_init_cli(GIOP_CliInf *);
CORBA_char *GIOP_create_reqbuf(CORBA_Object, GIOP_CliInf *, CORBA_unsigned_long, CORBA_boolean, CORBA_char *, CORBA_Environment *);
CORBA_char *GIOP_invoke_req(CORBA_Object, GIOP_CliInf *, CORBA_unsigned_long, CORBA_Environment *);
void GIOP_send_repexc(GIOP_SrvInf *, CORBA_char *, CORBA_unsigned_long);
CORBA_char *GIOP_create_repbuf(GIOP_SrvInf *, CORBA_unsigned_long);
void GIOP_send_rep(GIOP_SrvInf *, CORBA_unsigned_long);

#endif /* __ECBGIOP_H__ */
